;    database.inc - contains database-functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
DBp_Setup_Factor_Edit:
	push ax
	mov ax, 256
	int 16h
	jnz .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push bp
	mov bp, Factorvelden
;	mov byte [MAXLINE], 11
	call DBp_Edit_Velden
	pop bp
	call Textp_Set_Active
	call Textp_InvAccToHorpos
.end	
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Setup_Uitslagen_Lijst_Printen:
	push bp
	mov bp, Groepinvoer
	mov word [bp+26], DBp_Groep_Uitslagen_Lijst_Printen
;	mov word [bp+26], DBp_Setup_Groep_Inv
	mov word [UPDATEFUNCTION], Empty_Proc
	pop bp
	call DBp_Setup_Groepen_Edit
	push bp
	mov bp, Groepinvoer
	mov word [bp+26], DBp_Setup_Groep_Inv
	mov word [UPDATEFUNCTION], FIp_Write_Data
	pop bp
	ret

DBp_Zoek_Leerling:
	push ax
	mov ax, 256
	int 16h
	jz $+5
	jmp .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push bx
	push cx
	push dx
	push di
	mov dl, 1
	mov dh, 9
	Textm_Calc_DI
	inc di
	mov cx, 26
	mov al, [Inv]
	Textm_Fill_DI_AL
	sub di, 2*26+1
	mov bx, StringBuffer
	mov byte [bx], 0
	push bp
	mov bp, Prestatievelden
	push word [Msg]
	mov word [Msg], VraagNaam
	call Statusb
.reenter	
	mov cx, 26
	mov bx, StringBuffer
	;DB2S [StringBuffer], 6
	call Toetsp_Input_String_DX
	jnc $+5
	jmp .exit
	Toetsm_Clear_Buffer
	;DB2S [StringBuffer], 0
	call PushString
	call DBp_Unselect
	call DBp_Select_Naam
	mov bx, [CURRTOTAL]
	call DBp_Print_Velden
	;call DBp_Unselect
	call PopString
	cmp bx, 1
	jg .meer
	jl .none
	push si
	xor si, si
	call Si_Beg_Record
	mov bl, [si]
	dec bl
	xor bh, bh
	mov bp,Groepinvoer
	mov [CURRPOS], bx
	mov [CURRBOVEN], bx
	mov bh, [MINLINE]
	mov [CURRLINE], bh
	;call DBp_Pos_Veld_Lowest
	call DBp_Print_Velden
	;mov dh, bl
	mov dh, [MINLINE]
	call Textp_SemiInvAccToHorpos
	mov si, UitslWijz
	mov word [Msg], Wijzig	
	call Bericht
	jc .tru
	mov bp, Prestatievelden
	mov byte [HORMIN], 1
	mov byte [HORMAX], 6
	mov byte [HORPOS], 1
	call DBp_Edit_Velden
	call FIp_Write_Data
	mov bp, Groepinvoer
.tru
	call Textp_Set_Unactive
	pop si
	;pop word [Msg]
	jmp .exit
.meer
	mov word [Msg], MeerNaam
	call Statusb
	jmp .reenter
.none
	push si
	mov si, GeenLLN
	call Bericht
	pop si
.exit
	pop word [Msg]
	mov bp, Prestatievelden
	call DBp_Unselect
	pop bp
	mov cx, 26
	mov ax, 0
	Textm_Fill_DI_AX
	pop di
	pop dx
	pop cx
	pop bx
	call Textp_Set_Active
	call Textp_InvAccToHorpos

.end
	Toetsm_Clear_Buffer
	pop ax
	ret
	
DBp_Setup_Groepen_Edit:
	push ax
	mov ax, 256
	int 16h
	jnz .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push bp
	mov bp, Groepinvoer
	push word [Msg]
	mov word [Msg], EditGroep
	call DBp_Edit_Velden
	pop word [Msg]
	pop bp
	call Textp_Set_Active
	call Textp_InvAccToHorpos
.end
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Setup_Klassement_Menu:
	push ax
	push bx
	mov ax, 256
	int 16h
	cmp word [Total], 0
	je .end
	mov ax, Klassementmenu
	mov bx, Klassemenuinfo
	call DBp_Execute_Menu
.end
	Toetsm_Clear_Buffer
	pop bx
	pop ax
	ret

DBp_Setup_Extra_Menu:
	push ax
	push bx
	mov ax, 256
	int 16h
	mov ax, Extramenu
	mov bx, Extramenuinfo
	call DBp_Execute_Menu
	Toetsm_Clear_Buffer
	pop bx
	pop ax
	ret
	
DBp_Setup_Factoren_Menu:
	push ax
	push bx
	mov ax, 256
	int 16h
	mov ax, Factorenmenu
	mov bx, Factorenmenuinfo
	call DBp_Execute_Menu
	Toetsm_Clear_Buffer
	pop bx
	pop ax
	ret
	
DBp_Execute_Menu:
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	call DBp_Save_Menuvelden
	push word [Menu]
	push word [Menu+2]
	mov word [Menu], ax
	mov word [Menu+2], bx
	push bp
	mov bp, Menuvelden
	call DBp_Load_Menuvelden
l	call DBp_Edit_Velden
	call DBp_Save_Menuvelden
	pop bp
	pop word [Menu+2]
	pop word [Menu]
	call DBp_Load_Menuvelden
	call DBp_Print_Velden
	call Textp_Set_Active
	call Textp_InvAccToHorpos
	ret

DBp_Setup_Klasse12_Menu:
	push ax
	mov ax, '2' + 256 * '3'
	jmp DBp_Setup_Klasse1x_Menu


DBp_Setup_Klasse14_Menu:
	push ax
	mov ax, '4' + 256 * '5'
	jmp DBp_Setup_Klasse1x_Menu

DBp_Setup_Klasse16_Menu:
	push ax
	mov ax, '6' + 256 * '7'
	jmp DBp_Setup_Klasse1x_Menu

DBp_Setup_Klasse18_Menu:
	push ax
	mov ax, '8' + 256 * '9'
	jmp DBp_Setup_Klasse1x_Menu

DBp_Setup_Klasse29_Menu:
	push ax
	mov ax, '2' + 256 * '9'
	jmp DBp_Setup_Klasse1x_Menu

DBp_Setup_Klasse1x_Menu:   ; Aanname: Wordt alleen aangeroepen door klassement
	mov [Klasse1xmenu+14], al
	mov [Klasse1xmenu+17], ah
	mov ax, 256
	int 16h
	jnz .end
	push bx
	mov ax, [CURRPOS]
	cmp al, 4
	je .tru
	call DBp_Select_Leeftijd
.tru	
	call DBp_Sort_Score
	push bp
	mov bp, Prestatievelden
	mov word [CURRPOS], 0
	mov word [CURRBOVEN], 0	
	call DBp_Print_Velden
	pop bp
	mov ax, Klasse1xmenu
	mov bx, Klas1xmenuinfo	
	call DBp_Execute_Menu
	call DBp_Unselect
	pop bx
.end
	Toetsm_Clear_Buffer
	pop ax
	ret
	
DBp_Setup_Uitsl_Edit:
	push ax
	mov ax, 256
	int 16h
	jnz .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push bp
	call DBp_GSelect
	mov bp, Selecteervelden
	push word [Msg]
	mov word [Msg], KiesGroep
	cmp word [CURRTOTAL], 0
	je .tru
	call DBp_Edit_Velden
.tru	
	pop word [Msg]
	call DBp_GUnselect
	pop bp
	call Textp_Set_Active
	call Textp_InvAccToHorpos
.end	
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Save_Menuvelden: 
	push ax
	push si
	mov si, [Menu+2]
	mov ax, [CURRPOS]
	mov [si+2], ax
	mov al, [CURRLINE]
	mov [si+4], al
	pop si
	pop ax
	ret 

DBp_Load_Menuvelden:
	push ax
	push si
	mov si, [Menu+2]
	mov ax, [si]
	mov [CURRTOTAL], ax
	mov ax, [si+2]
	mov [CURRPOS], ax
	mov al, [si+4]
	mov [CURRLINE], al
	pop si
	pop ax
	ret
	
DBp_Groep_Uitslagen_Lijst_Printen:
	push ax
	mov ax, 256
	int 16h
	jnz .exit
	push si
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	mov si, [CURRPOS]
	call DBp_Groep_AL_SI
	xor ah, ah
	test byte [si], 2
	je .end
	call DBp_Select_Groep
	push bp
	mov bp, Prestatievelden
	call Print_Uitslagen_Lijst
	pop bp
	call DBp_Unselect	
.end
	call Textp_Set_Active
	call Textp_InvAccToHorpos
	pop si
.exit
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Setup_Groep_Inv:
	push ax
	mov ax, 256
	int 16h
	jnz .end
	push si	
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	mov si, [CURRPOS]
	call DBp_Groep_AL_SI
	xor ah, ah
	;mov si, Opgevuld -1
	;add si, ax
	;mov al, [si]
	;and al, 2
	test byte [si], 2
	jne .door2
	jmp .bestaatniet ;de groep bestaat niet
.door2	
	cmp word [Total], 1024
	jne .door
	mov si, Full
	call Bericht
	jmp .continue
.end
	Toetsm_Clear_Buffer
	pop ax
	ret
.door
	push cx
	mov cx, [Total]
	mov si, cx
	dec si
	call Si_Beg_Record
.searchloop
	cmp [si], al
	je .tru
	sub si, 43
	loop .searchloop
.tru
	pop cx
	mov ah, [si+28]
	;DB2S ah, 0, 40
	;DW2S [Total], 0, 5
	call DBp_Select_Groep
	push bp
	mov bp, Prestatievelden
	;DW2S [CURRTOTAL], 0, 15
	pop bp
	call DBp_Unselect
	push bx
	mov bx, -1
	call DBp_Nieuwe_Leerling
	pop bx
.continue	
	;pop ax
	;push ax
	call DBp_Select_Groep
	call DBp_Unselect
	call DBp_Select_Groep
	push bp
	mov bp, Prestatievelden
	;DW2S [CURRTOTAL], 0, 0
	;DW2S [Total], 0, 10
	mov byte [HORMIN], 0
	mov byte [HORMAX], 0	
	mov byte [HORPOS], 0
	mov al, [MINLINE]
	mov [CURRLINE], al
	mov word [MovesDown], 1
	mov byte [Deelinvoer], 1
	call DBp_Pos_Veld_Lowest
	call DBp_Edit_Velden
	mov byte [Deelinvoer], 0
	mov word [MovesDown], 0
	mov si, [CURRTOTAL]
	dec si	
	call Si_Beg_Record
	dec word [CURRTOTAL]
	jnz .tru2
	mov al, [si]
	;DB2S al, 1, 0
	xor ah, ah
	push di
	mov di, Opgevuld-1
	add di, ax
	mov byte [di], 0
	pop di
	mov bp, Groepinvoer
	call DBp_Print_Velden
	mov bp, Prestatievelden
.tru2
	call DBp_Move_Down
	call DBp_Print_Velden
	call DBp_Unselect
	pop bp
.exit
	call Textp_Set_Active
	call Textp_InvAccToHorpos
	pop si
	jmp .end
.bestaatniet
	; Maak een nieuwe leerling aan in groepnummer al
	push bx
	push cx
	cmp word [Total], 1024
	je .full
	mov bl, al
	call Kies_Leeftijd
	jc .tochniet
	;push ax
	mov ah, al
	mov cl, ah
	mov al, bl
	mov bx, 0
	;DW2S ax, 0
	call DBp_Nieuwe_Leerling
	;DW2S ax, 10
	mov si, Opgevuld-1
	xor ah, ah
	add si, ax
	mov byte [si], 2
	mov si, Leeftijden-1
	add si, ax
	;pop ax	
	mov [si], cl 
	push bp
	mov bp, Groepinvoer
	call DBp_Print_Velden
	pop bp
	pop cx
	pop bx
	jmp .continue
.tochniet
	pop cx
	pop bx
	jmp .exit
.full
	mov si, Full
	call Bericht
	jmp .tochniet

DBp_Pos_Veld_Lowest:
	push ax
	mov ax, [CURRTOTAL]
	dec ax
	mov [CURRPOS], ax
	mov al, [MAXLINE]
	sub al, [MINLINE]
	xor ah, ah
	cmp ax, [CURRPOS]
	jge .tru
	push bx
	mov bx, [CURRPOS]
	sub bx, ax
	mov [CURRBOVEN], bx
	pop bx
	mov al, [MAXLINE]
	mov [CURRLINE], al
	jmp .end
.tru	
	mov word [CURRBOVEN], 0
	mov ax, [CURRPOS]
	;DB2S al, 0, 40
	add al, [MINLINE]
	;DB2S al, 0, 43
	mov [CURRLINE], al
.end
	pop ax
	ret

DBp_Nieuwe_Leerling: ; maak nieuwe leerling aan (naamloos) 
                     ; in groep al met leeftijd ah en wel de bx-de leerling
	push bx
	push cx
	push si
	push ax
	mov si, Leerlingen	; si wijst na de eerste leerling
	mov cx, [Total]
	jcxz .reallymatch
.detectloop
        cmp [si], al
 	je .match
	jg .reallymatch
	add si, 43
	loop .detectloop
	jmp .reallymatch
.match
	cmp bx, 0
	je .reallymatch
	dec bx
	add si, 43
	loop .detectloop
.reallymatch
	call DBp_Move_Up
	mov [si], al
	inc si
	mov cx, 26
.naam_loop
	mov byte [si], 32
	inc si
	loop .naam_loop
	inc si
	mov [si], ah
	dec si
	mov al, [Geslacht]
	mov [si], al
	sub si, 27
	call DBp_Clear_Score
;	mov cx, 6
;.prestatie_loop
;	inc si
;	inc si
;	mov word [si], 2710h
;	loop .prestatie_loop
;	inc si
;	inc si
;	mov word [si], 0

	inc word [Total]
	push bp
	mov bp, Prestatievelden
	mov bx, [CURRTOTAL]
	shl bx, 1
	add bx, Reference

;	sub si, 41
	mov [bx], si
	inc word [CURRTOTAL]
	pop bp
	pop ax
	pop si
	pop cx
	pop bx
	ret

DBp_Clear_Score:  ; si wijst naar leerling record
	push cx
	add si, 27
	mov cx, 6
.prestatie_loop
	inc si
	inc si
	mov word [si], 2710h
	loop .prestatie_loop
	inc si
	inc si
	mov word [si], 0
	sub si, 41
	pop cx
	ret

DBp_CX_43DI_LL_SI:
	mov cx, di
	shl di, 1
	add cx, di
	shl di, 1
	shl di, 1
	add cx, di
	shl di, 1
	shl di, 1
	add cx, di
	add cx, Leerlingen
	sub cx, si
	ret

DBp_Move_Down:  ;si is het adres van de leerling de verdwijnt
		;word [Total] verminderd met \'e\'en
	push cx
	push di
	push si
	mov di, [Total]		;totaal aantal leerlingen
	dec di
	mov [Total], di		;cx en word [Total] met een verlagen
	call DBp_CX_43DI_LL_SI
	jcxz .end
	mov di, ds		;zet es even op ds voor rep movsb
	mov es, di
	mov di, si	
	add si, 43		;source index staat goed
	cld			;di en si moeten oplopen
	rep movsb
	mov si, [TextSeg]
	mov es, si		;es terugzetten
.end
	pop si
	pop di
	pop cx
	ret
	

DBp_Move_Up: ;gooi alle leerlingen waar si naar wijst 43 bytes naar boven
	     ;en herstel si (si wijst dan naar een lege plaats
             ;strategie: bepaal de hoeveelheid bytes die moet worden
	     ;verplaatst en doe rep movsb op een slimme manier
	push si
	push di
	push cx
	mov di, [Total]
	call DBp_CX_43DI_LL_SI
	jcxz .end
	mov di, ds
	mov es, di
	add si, cx
	dec si
	mov di, si
	add di, 43
	std
	rep movsb
	mov si, [TextSeg]
	mov es, si
.end
	pop cx
	pop di
	pop si
	ret

DBp_Setup_Inv:
	push ax				; ax
	mov ax, 256
	int 16h
	jz $+5
	jmp .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push si				; si, ax
	mov si, [CURRPOS]
	call DBp_Groep_AL_SI
	pop si				; ax
	call DBp_Check_Ingevuld
	jnc $+5 
	jmp .exit
	call DBp_Select_Groep
	mov al, [HORPOS]
	push si				; si, ax
	push bx				; bx, si, ax
	push bp				; bp, bx, si, ax
	mov si, 0
	call Si_Beg_Record
	mov bl, [si+28]
	pop bp				; bx, si, ax
	push bp				; bp, bx, si, ax
	mov bp, Factorvelden
	push dx				; dx, bp, bx, si, ax
	xor ah, ah
	mov si, ax
	shl si, 1
	shl si, 1
	shl si, 1
;	mov byte [MAXLINE], 10
	cmp byte [Geslacht], 'M'
	je .tru5
	add si, 4
.tru5
	push word [CURRBOVEN]		; [CB], dx, bp, bx, si, ax
	mov [CURRBOVEN], si
	call DBp_Print_Velden	
	push dx				; dx, [CP], [CB], dx, bp, bx, si, ax
	mov dh, 3
	mov dl, 45
	add dh, bl
	Textm_Calc_DI
	inc di
	push cx				; cx, dx, [CP], [CB],dx,bp,bx,si,ax
	push ax				; ax,cx,dx,[CP],[CB],dx,bp,bx,si,ax
	mov al, [Inv]
	mov cx, 5
	Textm_Fill_DI_AL
	pop ax				; cx,dx,[CP],[CB],dx,bp,bx,si,ax
	pop cx				; dx,[CP],[CB],dx,bp,bx,si,ax
	pop dx				; dx,[
	pop word [CURRBOVEN]
;	mov dh, 11
;	call [CLEARLINE]
	pop dx
	pop bp
	pop bx
	pop si
	push bp
	mov bp, Prestatievelden
	add al, 1
	mov [HORMIN], al
	mov [HORMAX], al
	mov [HORPOS], al
	mov al, [MINLINE]
	mov [CURRLINE], al
	mov word [MovesDown], 1
	call DBp_Edit_Velden
	mov word [MovesDown], 0
	push si
	mov si, 0
	call Si_Beg_Record
	push dx
	mov dh, 3
	add dh, [si+28]
	mov dl, 45
	Textm_Calc_DI	
	inc di
	push ax
	push cx
	mov cx, 5
	mov ax, 0
	mov al, [Wit]
	Textm_Fill_DI_AL
	pop cx
	pop ax
	pop dx
	pop si
	call DBp_Unselect
	pop bp
	call Markeren
.exit	
	call Textp_Set_Active
	call Textp_InvAccToHorpos
	
.end	
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Setup_Preview:
	push ax				; ax
	mov ax, 256
	int 16h
	jz $+5
	jmp .end
	call Textp_Set_Unactive
	call Textp_SemiInvAccToHorpos
	push bp
	mov bp, Prestatievelden
	cmp word [CURRTOTAL], 0
	je .end2
	mov al, 7
	mov [HORMIN], al
	mov [HORMAX], al
	mov [HORPOS], al
	mov al, [MINLINE]
	mov [CURRLINE], al
	mov word [CURRPOS], 0
	mov word [CURRBOVEN], 0
	mov word [MovesDown], 1
	call DBp_Edit_Velden
	mov word [MovesDown], 0
.end2	
	pop bp
;	call Markeren
.exit	
	call Textp_Set_Active
	call Textp_InvAccToHorpos
	
.end	
	Toetsm_Clear_Buffer
	pop ax
	ret

DBp_Check_Ingevuld:
	push ax
	push cx
	push si
	mov si, [CURRPOS]
	call DBp_Groep_AL_SI
	mov cl, [HORPOS]
	mov ch, [si]
	shl ch, cl
	and ch, 128
	jz .end
	mov si, WijzigenMsg
	call Bericht
.end
	pop si
	pop cx
	pop ax
	ret
	
;Si_Beg_Record:  ;SI is de huidige record in ref, SI wordt het startadres 
;	push ax
;	shl si, 1           ;SI*2
;	mov ax, [Reference+si]
;	mov si, ax   ; ax = de hoeveelste
;	shl ax, 1
;	add si, ax
;	shl ax, 1
;	shl ax, 1
;	add si, ax
;	shl ax, 1
;	shl ax, 1
;	add si, ax       
;	add si, Leerlingen  ; si = adres in database
;	pop ax
;	ret

Si_Beg_Record:
	shl si, 1
	add si, Reference
	mov si, [si] ; Mag dit? Blijkbaar
	ret

DBp_Groep_AL_SI:	;groepref-1 in si => addr groepbyte in si, nummer in ax
	mov ax, si
	mov si, GroepRef
	add si, ax
	mov al, [si]
	mov si, Opgevuld-1
	add si, ax
	ret

DBp_Input_Naam:  ;(plaats in dh, dl; breedte in cx; offset in record bx)
	push ax
	push di
	push si
	mov si, [CURRPOS]
	call Si_Beg_Record
	cmp di, 5300h
	je .delete
	cmp di, 5200h
	jne $+5
	jmp .insert
	add si, bx
	mov byte [StringBuffer], 0
.retry
	call Toetsp_Input_String_DX
	jc .end
	cmp byte [StringBuffer], 0
	je .delete2
	call DBp_Unique_Name
	jc .tru2
	push si
	mov si, NietUniek
	call Bericht
	pop si
	call Statusb
	jmp .retry
.back
.tru2
	mov di, StringBuffer+1
	push cx
	push si
.copy_loop:
	mov al, [di]
	mov [si], al
	inc di
	inc si
	loop .copy_loop
	pop si
	pop cx
	mov ax, [CURRTOTAL]
	dec ax
	cmp ax, [CURRPOS]
	jne .end
	sub si, bx
	mov al, [si]
	mov ah, [si+28]
	;DB2S al, 0, 0
	;DB2S ah, 0, 3
	push bx
	mov bx, -1
	call DBp_Nieuwe_Leerling
	pop bx

	;DB2S al, 0, 6
	;DB2S ah, 0, 9
	;call DBp_Pos_Veld_Lowest
	;call DBp_Veld_Down
	call DBp_Print_Velden
.end
	call Textp_Calc_DI
	Textm_Disp_Naam_DI
	pop si
	pop di
	pop ax
	ret
.delete
	Toetsm_Input
.delete2
	mov ax, [CURRTOTAL]
	dec ax
	cmp ax, [CURRPOS]
	je .end
	push si
	mov si, WissenMsg
	call Bericht
	pop si
	jc .end
.delfast
	call DBp_Move_Down
	dec word [CURRTOTAL]
	call DBp_Print_Velden
	mov word [MovesDown], 2
	jmp .end
.insert
	inc word [Total]
	call DBp_Move_Up
	call DBp_Clear_Score
	push si
	mov si, [CURRTOTAL]
	shl si, 1
	add si, Reference
	mov ax, [si-2]
	add ax, 43
	mov [si], ax
	pop si
	inc word [CURRTOTAL]
	call DBp_Print_Velden
	call Statusb
	add si, bx
	mov byte [StringBuffer], 0
.retry2	
	call Toetsp_Input_String_DX
	jc .delfast
	cmp byte [StringBuffer], 0
	je .delete2
	call DBp_Unique_Name
	jc .tru3
	push si
	mov si, NietUniek
	call Bericht
	pop si
	call Statusb
	jmp .retry2
.tru3
	jmp .back	 

DBp_Unique_Name: ;vergelijk stringbuffer met alle namen in Leerlingen;
	push ax
	push bx
	push cx
	push si
	mov bx, StringBuffer
	mov al, [bx]
	mov byte [bx], 26
	mov si, Leerlingen
	mov cx, [Total]
	jcxz .end2
.loop
	call DBp_Compare_Naam
	jnc .end
	add si, 43
	loop .loop
.end2
	stc
.end
	mov byte [bx], al
	pop si
	pop cx
	pop bx
	pop ax
	ret	

DBp_Input_Prestatie:  ;(plaats in dh, dl; breedte in cx; offset in record bx)
	push ax
	push bx
	push di
	push si
	mov si, [CURRPOS]
	call Si_Beg_Record
	add si, bx 
	mov byte [StringBuffer], 0
.return:    
	call Toetsp_Input_String_DX
	jc .end
	mov bx, si
	mov si, StringBuffer
	call Conv_String2FTPBuffer
	mov si, bx
	jc .error
	mov bx, 9999
	mov al, 3
	call Conv_FTPBuffer2AX
	jc .error
	mov [si], ax
.end:
	mov ax, [si]
	cmp ax, 02710h
	jne .tru6
	mov si, Leeg
	jmp .disp6
.tru6:
	call Conv_AX2BCD
	mov al, 3
	call Conv_BCD2String
	mov si, StringBuffer
.disp6: 
	mov al, ' '
	call Textp_Fill_RField_DH_DL
	mov si, StringBuffer
	mov byte [si], 0
	pop si
	pop di
	pop bx
	pop ax
	ret
.error
	cmp ah, 255
	je .empty
	call Invoer_Error
	jc .end
	jmp .return
.empty:
	mov word [si], 02710h
	jmp .end    

;DBp_Input_Factor:  ;(plaats in dh, dl; breedte in cx; offset in record bx)
;	push ax
;	push bx
;	push di
;	push si
;	mov si, [CURRPOS]
;	mov ax, si
;	shl ax, 1
;	add si, ax
;	shl si, 1
;	add si, Factors
;	add si, bx 
;	mov byte [StringBuffer], 0
;.return:    
;	call Toetsp_Input_String_DX
;	jc .end
;	mov bx, si
;	mov si, StringBuffer
;	call Conv_String2FTPBuffer
;	mov si, bx
;	jc .error
;	mov bx, 9999
;	mov al, 3
;	call Conv_FTPBuffer2AX
;	jc .error
;	mov [si], ax
;.end:
;	mov ax, [si]
;	cmp ax, 02710h
;	jne .tru6
;	mov si, Leeg
;	jmp .disp6
;.tru6:
;	call Conv_AX2BCD
;	mov al, 3
;	call Conv_BCD2String
;	mov si, StringBuffer
;.disp6: 
;	mov al, ' '
;	call Textp_Fill_RField_DH_DL
;	mov si, StringBuffer
;	mov byte [si], 0
;	pop si
;	pop di
;	pop bx
;	pop ax
;	ret
;.error
;	cmp ah, 255
;	je .empty
;	call Invoer_Error
;	jc .end
;	jmp .return
;.empty:
;	mov word [si], 02710h
;	jmp .end    

;DBp_Input_Geslacht:  ;(plaats in dh, dl; breedte in cx; offset in record bx)
;	push ax
;	push bx
;	push di
;	push si
;	mov si, [CURRPOS]
;	call Si_Beg_Record
;	add si, bx
;	mov bx, StringBuffer+1
;	mov byte [bx-1], 1
;	mov al, [si]
;	mov [bx], al
;	call Textp_Calc_DI
;	Textm_Put_Cursor@DX
;	Textm_Cursor_On
;opnieuw:
;	Toetsm_Poll
;	call Toetsp_Ck_Extern_Toets
;	jc .enter
;	cmp ax, 011Bh
;	je .end
;	cmp ax, 03920h
;	je .toggle
;	cmp al, 'M'
;	jne $+8
;	mov byte [bx], 'M'
;	jmp .disp
;	cmp al, 'm'
;	jne $+8
;	mov byte [bx], 'M' 
;	jmp .disp
;	cmp al, 'V'
;	jne $+8
;	mov byte [bx], 'V'
;	jmp .disp
;	cmp al, 'v'
;	jne opnieuw
;	mov byte [bx], 'V'
;.disp:
;	mov al, [bx]
;	Textm_Output_AL_DI
;	sub di, 2
;	jmp opnieuw
;.toggle:
;	mov al, 'M'
;	cmp byte [bx], 'M'
;	jne .xchg
;	mov al, 'V'
;.xchg:
;	mov [bx], al
;	jmp .disp
;.enter:
;	mov al, [bx]
;	mov [si], al
;.end:   
;	mov al, [si]
;	Textm_Output_AL_DI
;	Textm_Cursor_Off
;	;mov byte [si-1], 0
;	pop si
;	pop di
;	pop bx
;	pop ax
;	ret 
	
;DBp_Input_Leeftijd:
;	push ax
;	push bx
;	push di
;	push si
;	mov si, [CURRPOS]
;	call Si_Beg_Record
;	add si, bx
;	mov bx, StringBuffer+1
;	mov byte [bx-1], 1
;	mov al, [si]
;	mov [bx], al
;	call Textp_Calc_DI
;	Textm_Put_Cursor@DX
;	Textm_Cursor_On
;opnieuw2:
;	Toetsm_Poll
;	call Toetsp_Ck_Extern_Toets
;	jnc $+5
;	jmp lenter
;	cmp ax, 011Bh
;	jne $+5
;	jmp lend
;	cmp ax, 03920h
;	je ltoggle
;	cmp al, '2'
;	jne $+8
;	mov byte [bx], 0
;	jmp ldisp
;	cmp al, '3'
;	jne $+8
;	mov byte [bx], 0 
;	jmp ldisp
;	cmp al, '4'
;	jne $+8
;	mov byte [bx], 1
;	jmp ldisp
;	cmp al, '5'
;	jne $+8
;	mov byte [bx], 1
;	jmp ldisp
;	cmp al, '6'
;	jne $+8
;	mov byte [bx], 2
;	jmp ldisp
;	cmp al, '7'
;	jne $+8
;	mov byte [bx], 2 
;	jmp ldisp
;	cmp al, '8'
;	jne $+8
;	mov byte [bx], 3
;	jmp ldisp
;	cmp al, '9'
;	jne opnieuw2
;	mov byte [bx], 3
;ldisp:
;	mov al, [bx]
;	push si
;	mov si, bx
;	Textm_Disp_Leeftijd_DI
;	pop si
;	sub di, 10
;	jmp opnieuw2
;ltoggle:
;	inc byte [bx]
;	and byte [bx], 011b
;	jmp ldisp
;lenter:
;	mov al, [bx]
;	mov [si], al
;lend:   
;	Textm_Disp_Leeftijd_DI
;	Textm_Cursor_Off
;	;mov byte [si-1], 0
;	pop si
;	pop di
;	pop bx
;	pop ax
;	ret 
		

;DBp_Input_Groep:  ;(plaats in dh, dl; breedte in cx; offset in record bx)
;	push ax
;	push bx
;	push di
;	push si
;	mov si, [CURRPOS]
;	call Si_Beg_Record
;	add si, bx 
;	mov byte [StringBuffer], 0
;.return:    
;	call Toetsp_Input_String_DX
;	jc .end
;	mov bx, si
;	mov si, StringBuffer
;	call Conv_String2FTPBuffer
;	mov si, bx
;	jc .error
;	mov bx, 99
;	mov al, 5
;	call Conv_FTPBuffer2AX
;	jc .error
;	cmp ax, 0
;	je .error
;	mov [si], al
;.end:
;	xor ax, ax
;	mov al, [si]
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;	mov si, StringBuffer
;	mov al, ' '
;	call Textp_Fill_RField_DH_DL
;	pop si
;	pop di
;	pop bx
;	pop ax
;	ret
;.error
;	call Invoer_Error
;	jc .end
;	jmp .return

Invoer_Error:
	push si
	mov si, InvoerErrorMsg
	call Bericht
	pop si
	ret
	
Markeren:
	Toetsm_Clear_Buffer
	push ax
	push cx
	push si
	mov si, [CURRPOS]
	call DBp_Groep_AL_SI
	mov cl, [HORPOS]
	mov al, 128
	shr al, cl
	push si
	mov si, MarkerenMsg
	call Bericht
	pop si
	jc .tru
	or [si], al	
	jmp .tru2
.tru
	not al
	and [si], al
.tru2	
	mov si, [CURRPOS]
	call [WRITELINE]
	pop si
	pop cx
	pop ax
	ret

Bericht:
	push ax
	push word [Msg]
	mov word [Msg], si
	call Statusb
	pop word [Msg]
.opnieuw:   
	Toetsm_Input
	cmp ax, 011Bh
	je .error
	cmp ax, 01C0Dh
	jne .opnieuw
	call Statusb
	clc
	pop ax
	ret
.error:
	stc
	pop ax
	ret

Kies_Leeftijd: ; returncode in ax als succesvol, anders carryset
	push word [Msg]
	mov word [Msg], KiesLT
	call Statusb
	pop word [Msg]
.opnieuw:
	Toetsm_Input
	cmp ax, 011Bh
	je .error
	cmp ax, 0332h
	je .end
	cmp ax, 0534h
	je .end
	cmp ax, 0736h
	je .end
	cmp ax, 0938h
	je .end
	jmp .opnieuw
.end
	xor ah, ah
	sub al, 32h
	shr al, 1
	clc
	ret
.error
	stc
	ret

DBp_Line_Edit:
	push ax
	push bx
	push cx
	push di
	push si
	call Textp_InvAccToHorpos
.input:
	Toetsm_Poll
	cmp ax, 011Bh
	jne $+5
	jmp .exit
	cmp ax, 04B00h
	jne $+5 
	jmp .left
	cmp ax, 0F00h
	jne $+5
	jmp .left
	cmp ax, 04D00h
	jne .tru2
	jmp .right
.tru2
	cmp ax, 0F09h
	jne $+5
	jmp .right
	cmp ax, 01C0Dh
	je .enter
	jmp .extern
.enter:
	Toetsm_Input
.toets:
	mov di, ax
	xor ax, ax
	xor si, si
	mov bx, 7
	mov al, [HORPOS]
	mul bl
	lea si, [VELDENINFO]
	add si, ax
	mov bl, [si+2]
	push word [Msg]
	mov ax, [si+3]
	mov [Msg], ax
	call Statusb
	xor cx, cx
	mov cl, [si+1]
	mov ax, [si+5]
	call ax
	pop word [Msg]
	;DW2S bp, 0
	;DW2S bp, 20
	call [UPDATEFUNCTION]
	call Statusb
	mov ax, 256
	int 16h
	jz .exp
	jmp .input
.exp	
	mov word [ToetsVoorEdit], 0
	cmp word [MovesDown], 0
	jne $+5
 	jmp .input
	cmp word [MovesDown], 2
	jne .tru4
	mov word [MovesDown], 1
	jmp .input
.tru4
	mov word [ToetsVoorEdit], 1
	jmp .exit
.left:
	Toetsm_Input
	mov al, [HORPOS]
	cmp [HORMIN], al
	jne .tru	
	jmp .input
.tru	
	dec al
	mov [HORPOS], al
	call Textp_InvAccToHorpos
	jmp .input
.right:
	Toetsm_Input
	mov al, [HORPOS]
	cmp [HORMAX], al
	jne $+5
	jmp .input
	inc al
	mov [HORPOS], al
	call Textp_InvAccToHorpos
	jmp .input
.exit:
	;call Textp_Clear_Attr_Line
	pop si
	pop di
	pop cx
	pop bx
	pop ax
	ret
.extern:
	cmp ax, 04800h   ; up
	je .exit
	cmp ax, 05000h   ; dn
	je .exit
	cmp ax, 04900h   ; pgup
	je .exit
	cmp ax, 05100h   ; pgdn
	je .exit
	cmp ax, 04700h   ; home
	je .exit
	cmp ax, 04F00h   ; end
	je .exit
	cmp ax, 03920h
	jne $+5 
	jmp .enter
	jmp .toets

DBp_Edit_Velden:
	push ax
	push cx
	push dx
	mov dh, [CURRLINE]
	call Textp_Set_Active
	call DBp_Print_Velden
Veld_Edit:  
	;DW2S [CurrPos], 0
	;mov dh, [CURRLINE]
	call Statusb
	call DBp_Line_Edit
	cmp word [ToetsVoorEdit], 1
	jne .tru
	mov word [ToetsVoorEdit], 0
	jmp Spec_Down
.tru	
	;DW2S [CurrPos], 160
	Toetsm_Poll
	cmp ax, 05000h
	je Veld_Down
	cmp ax, 04800h
	je Veld_Up
	cmp ax, 05100h
	je Veld_PgDn
	cmp ax, 04900h
	je Veld_PgUp
	cmp ax, 04700h
	je  Veld_Home
	cmp ax, 04F00h
	je Veld_End
	cmp ax, 011Bh
	jne Veld_Edit
Veld_Exit:
	call Textp_Set_Unactive
	pop dx
	pop cx
	pop ax
	ret
Veld_Up:
	Toetsm_Input
	call DBp_Veld_Up
	jmp Veld_Edit
Veld_Down:
	Toetsm_Input
Spec_Down:
	call DBp_Veld_Down
	jmp Veld_Edit
Veld_PgDn:
	Toetsm_Input
	mov al, [MAXLINE]
	sub al, [MINLINE]
	xor ch, ch
	mov cl, al
.downloop
	call DBp_Veld_Down
	loop .downloop
	jmp Veld_Edit
Veld_PgUp:
	Toetsm_Input
	mov al, [MAXLINE]
	sub al, [MINLINE]
	xor ch, ch
	mov cl, al
.uploop
	call DBp_Veld_Up
	loop .uploop
	jmp Veld_Edit
Veld_Home:
	Toetsm_Input
	mov cx, [CURRPOS]
	jcxz .back
.uploop
	call DBp_Veld_Up
	loop .uploop
.back
	jmp Veld_Edit
	
;.end
Veld_End:
	Toetsm_Input
	mov cx, [CURRTOTAL]
	sub cx, [CURRPOS]
	dec cx
	jcxz .back
.downloop
	call DBp_Veld_Down
	loop .downloop
.back
	jmp Veld_Edit
	jmp Veld_Edit       
	
DBp_Veld_Up: 
	mov ax, [CURRPOS]
	cmp ax, 0
	jne .tru
	ret
.tru
	dec ax
	mov [CURRPOS], ax
	cmp dh, [MINLINE]
	je .scroll_down
	call Textp_Clear_Attr
	dec dh
	mov [CURRLINE], dh
	ret
.scroll_down
	dec word [CURRBOVEN]
	call DBp_Schuif_Omlaag
	ret

DBp_Veld_Down:
	mov ax, [CURRPOS]
	inc ax
	cmp ax, [CURRTOTAL]
	jne .tru
	ret
.tru
	mov [CURRPOS], ax
	cmp dh, [MAXLINE]
	je .scroll_up
	call Textp_Clear_Attr
	inc dh
	mov [CURRLINE], dh
	ret
.scroll_up
	inc word [CURRBOVEN]
	call DBp_Schuif_Omhoog
	ret

DBp_Schuif_Omhoog:
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	xor cx, cx
	mov ax, cx
	mov dh, [MINLINE]
	mov cl, [MAXLINE]
	sub cl, dh
	mov dl, [SCROLLBEGIN]  
	inc dh
	call Textp_Calc_DI
	mov si, di
	sub di, 160
	mov al, [SCROLLAANTAL] 
	inc al
	mov bx, 80
	sub bl, al
	shl bx, 1
	jcxz .no_scroll
	cld
.line_loop	
	push cx
	mov cx, ax
.again:
	es movsb
	inc si
	inc di
	loop .again
	pop cx
	add si, bx
	add di, bx
	loop .line_loop
.no_scroll    
	mov si, [CURRPOS]
	mov dh, [CURRLINE]
	call [WRITELINE]
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret

DBp_Schuif_Omlaag:
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	xor cx, cx
	mov ax, cx
	mov dl, [MINLINE]
	mov cl, [MAXLINE]
	mov dh, cl
	sub cl, dl
	mov dl, [SCROLLBEGIN]
	mov al, [SCROLLAANTAL]
	add dl, al
	dec dh
	call Textp_Calc_DI
	mov si, di
	add di, 160
	inc al
	mov bl, 80
	sub bl, al 
	shl bx, 1
	std
	jcxz .no_scroll
.line_loop
	push cx	
	mov cx, ax
.again:
	es movsb
	dec si
	dec di
	loop .again
	pop cx
	sub si, bx
	sub di, bx
	loop .line_loop
.no_scroll:    
	mov si, [CURRPOS]
	mov dh, [CURRLINE]
	call [WRITELINE]
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret

DBp_Print_Velden:
	push ax
	push dx
	push si
	mov dh, [MINLINE]
	mov si, [CURRBOVEN]
	cmp word [CURRTOTAL], 0
	je .clr
.nextline:  
	call [WRITELINE]
	inc dh
	cmp dh, [MAXLINE]
	ja .end
	inc si
	cmp si, [CURRTOTAL]
	je .clr
	jmp .nextline
.clr:
	call [CLEARLINE]
	inc dh
	cmp dh, [MAXLINE]
	ja .end
	jmp .clr
.end:
	pop si
	pop dx
	pop ax
	ret

DBp_Sort_Score:
	push cx
	push bp
	mov bp, Prestatievelden
	mov cx, [CURRTOTAL]
	;DW2S cx, 0, 0
	jcxz .end
	dec cx
	jz .end		
	push word [Msg]
	mov word [Msg], SorteerMsg
	call Statusb
	push ax
	push bx
	push dx
	push si
	mov dx, 0
.first_loop
	push cx
.second_loop
	mov si, cx
	add si, dx
	call Si_Beg_Record
	mov ax, [si+41]
	mov si, cx
	add si, dx
	dec si
	call Si_Beg_Record
	cmp ax, [si+41]
	je .arbiter
	jb .tru
	mov si, cx
	add si, dx
	shl si, 1
	add si, Reference
	mov ax, [si]
	mov bx, [si-2]
	mov [si-2], ax
	mov [si], bx
.tru	
	loop .second_loop
	inc dx
	pop cx
	loop .first_loop
	pop si
	pop dx
	pop bx
	pop ax
	pop word [Msg]
	call Statusb
.end	
	pop bp
	pop cx
	ret
.arbiter
	jmp .tru

;DBp_Unselect:
;	push bx
;	push cx
;	push si
;	push bp
;	mov bp, Prestatievelden
;	xor bx, bx
;	mov cx, [Total]
;	mov [CURRTOTAL], cx
;	mov [CURRPOS], bx
;	mov [CURRBOVEN], bx
;	mov si, Reference
;.fill_loop:
;	mov [si], bx
;	inc bx
;	add si, 2
;	loop .fill_loop
;	pop bp
;	pop si
;	pop cx
;	pop bx
;	ret
	
DBp_Unselect: ;destroys cx
	push bp
	mov bp, Prestatievelden
	mov cx, [Total]
	jcxz .end
	push bx
	xor bx, bx
	mov [CURRTOTAL], cx
	mov [CURRPOS], bx
	mov bl, [MINLINE]
	mov [CURRLINE], bl
	push di
	push si
	mov di, Leerlingen
	mov si, Reference
.fill_loop
	mov [si], di
	add si, 2
	add di, 43
	loop .fill_loop
	pop si
	pop di
	pop bx
.end
	pop bp
	ret
	
DBp_Compare_Naam:
	push ax
	push bx
	push cx
	push si
	xor ch, ch
	mov cl, [bx]
	;push di
	;xor di, di
	;mov al, [bx+1]
	;Textm_Output_AL_DI
	;mov al, [si+1]
	;Textm_Output_AL_DI	
	;pop di
	jcxz .end3
.loop
	inc si
	inc bx
	mov al, [si]
	cmp al, [bx]
	;DB2S [si], 0
	;DB2S [bx], 6
	jne .end2
	loop .loop
	;DW2S si, 0
.end3
	clc
	jmp .end
.end2	
	stc
.end
	pop si
	pop cx
	pop bx
	pop ax
	ret

DBp_Compare_8bit:
	clc
	cmp al, [si+bx]
	je .tru	
	stc
.tru
	ret

DBp_Select_Naam: ;Pascal string in bx
	push bx
	mov word [CompareFunction], DBp_Compare_Naam
	jmp DBl_Select

DBp_Select_Leeftijd: ;leeftijdscode in al
	push bx
	mov bx, 28
	mov word [CompareFunction], DBp_Compare_8bit
	jmp DBl_Select
	
DBp_Select_Groep: ;groepnummer in al
	push bx
	xor bx, bx
	mov word [CompareFunction], DBp_Compare_8bit
DBl_Select:
	push cx
	push bp
	mov bp, Prestatievelden
	mov cx, [CURRTOTAL]
	jcxz .end
	push si
	push di
	push dx
	mov di, Reference
.select_loop
	mov si, cx
	neg si
	add si, [CURRTOTAL]
	mov dx, si
	call Si_Beg_Record
;	cmp al, [si+bx]
;	jne .tru
	call [CompareFunction]
	jc .tru
	mov si, dx
	shl si, 1
	add si, Reference
	mov dx, [si]
	mov [di], dx
	add di, 2
.tru
	loop .select_loop
	sub di, Reference
	shr di, 1
	;DW2S di, 0, 0
	mov [CURRTOTAL], di
	mov word [CURRPOS], 0
	mov word [CURRBOVEN], 0
	mov bl, [MINLINE]
	mov [CURRLINE], bl
	pop dx
	pop di
	pop si
.end
	pop bp
	pop cx
	pop bx
	ret

DBp_GUnselect: ;destroys cx
	push bp
	mov bp, Selecteervelden
	mov cl, [GTotal]
	xor ch, ch
	jcxz .end
	push bx
	xor bx, bx
	mov [CURRTOTAL], cx
	mov [CURRPOS], bx
	mov bl, [MINLINE]
	mov [CURRLINE], bl
	push si
	mov si, GroepRef-1
 	xor bx, bx
.fill_loop:
	inc bl
	mov [si+bx], bl
	loop .fill_loop
	pop si
	pop bx
.end
	pop bp
	ret
	
DBp_GSelect:
	push cx
	push bp
	mov bp, Selecteervelden
	mov cx, [CURRTOTAL]
	jcxz .end
	push si
	push di
	mov di, GroepRef
	;DB2S [di],0,0
.select_loop:
	mov si, cx
	neg si
	add si, [CURRTOTAL]
	call DBp_Groep_AL_SI
	test byte [si], 2
	je .tru
	mov byte [di], al
	inc di
.tru
	loop .select_loop
	sub di, GroepRef
	mov [CURRTOTAL], di
	mov word [CURRPOS], 0
	mov word [CURRBOVEN], 0
	mov cl, [MINLINE]
	mov [CURRLINE], cl
	pop di
	pop si
.end
	pop bp
	pop cx
	ret
		
DBp_MenuDispatcher:
	push ax
	push si	
	push dx
	mov si, [CURRPOS]
	inc si
	mov ax, 22
	mul si
	pop dx
	mov si, ax
	add si, [Menu]
	sub si, 2
	call [si]
	pop si
	pop ax
	ret