;    printer.inc - printing functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
Print_Factoren:
	Toetsm_Clear_Buffer
	push ax
	push cx
	push dx
	mov dx, Hoofdmenu+22*3
	mov cx, 9
	call Print_print
	mov dx, Facts+1
	mov cx, 8
	call Print_print
	call Print_1013
	call Print_1013
	mov dx, Legenda3+30
	mov cx, 38
	call Print_print
	call Print_1013
	mov dx, Legenda4+30
	mov cx, 38
	call Print_print
	call Print_1013
	mov cx, 6
	push bx
	push di
	push si
	mov bx, Factors
	mov si, OnderArray
	mov ah, 5
.outer_loop
	push cx
	mov byte [DOSString], 0
	mov cx, 2
.gesl_loop
	push cx
	mov cx, 4	
	mov di, GroepArray
	;DB2S al, 0
.groep_loop
	push cx
	mov dx, si
	mov cx, 12
	call Print_print
	mov dl, ' '
	int 21h
	mov dl, 'M'
	cmp byte [DOSString], 0
	je .tru
	mov dl, 'V'
.tru	
	int 21h
	mov dl, ' '
	int 21h
	mov dx, di
	mov cx, 5
	call Print_print
	mov cx, 3
.getallen_loop
	push cx
	mov dl, ' '
	int 21h
	mov cl, 3
	push si
	push ax
	mov si, StringBuffer	
	call Textp_Make_String_2Data
	pop ax
	add bx, 2
	mov cx, 5
	call Print_String_LField
	pop si
	pop cx
	loop .getallen_loop
	call Print_1013
	add di, 5
	pop cx
	loop .groep_loop
	inc byte [DOSString]
	pop cx
	loop .gesl_loop
	add si, 12
	pop cx
	loop .outer_loop
	pop si
	pop di
	pop bx
	pop dx
	pop cx
	pop ax
	ret

Print_Uitslagen_Lijst:
	push ax			; ax
	push bx
	push cx			; cx, ax
	push dx			; dx, cx, ax
	push si			; si, dx, cx, ax
	call Print_1013
	mov dx, Onderdeel
	mov cx, 10
	call Print_print
	mov dx, Leeg+1
	mov cx, 5
	call Print_print
	call Print_print
	call Print_print
	mov dx, Legenda2+1
	mov cx, 20
	call Print_print
	mov dx, Groep
	mov cx, 6
	call Print_print
	xor si, si
	call Si_Beg_Record
	mov al, [si]
	xor ah, ah	
	;DW2S ax, 0
	mov si, StringBuffer
	cmp byte [Geslacht], 'M'
	je .tru3
	mov byte [StringBuffer], 2
	add al, 64
	mov byte [StringBuffer+1], al
	mov byte [StringBuffer+2], ' '
	jmp .tru2
.tru3
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	;DB2S [si], 0
	cmp byte [si], 1
	jne .tru2
	inc byte [si]
	mov byte [StringBuffer+2], ' '
.tru2
	mov cx, 3
	call Print_String_LField

	call Print_1013
	
	call Print_1013

	mov al, ''
	mov word [Naamnaam], Legenda5+1
	mov word [Decoratie], Legenda5+1
	mov bl, ''
	mov bh, ''

	call Uitsl_Print_Line
	
	mov al, ''
	mov word [Naamnaam], BreedPrint
	mov word [Decoratie], Poging
	mov bl, ''
	mov bh, bl
	call Uitsl_Print_Line

	mov cx, [CURRTOTAL]
	add cx, 3
	;DW2S cx, 0
	xor si, si
.line_loop

	mov al, ''
	mov word [Naamnaam], Legenda5+1
	mov word [Decoratie], Legenda5+1
	mov bl, ''
	mov bh, ''
	call Uitsl_Print_Line

	mov al, ''
	cmp si, [CURRTOTAL]
	mov word [Naamnaam], BreedPrint
	jnl .tru
	push si	
	call Si_Beg_Record
	lea bx, [si+1]
	mov word [Naamnaam], bx
	pop si
.tru
	mov word [Decoratie], BreedPrint
	mov bl, ''
	mov bh, ''
	call Uitsl_Print_Line
					
	inc si
	loop .line_loop
	
	mov al, ''
	mov word [Naamnaam], Legenda5+1
	mov word [Decoratie], Legenda5+1
	mov bl, ''
	mov bh, ''
	call Uitsl_Print_Line
	call Print_1013
	call Print_1013
	mov dx, Paraaf
	mov cx, 7
	call Print_print
	mov dx, Leeg+1
	mov cx, 5
	call Print_print
	call Print_print
	call Print_print
	call Print_1013

	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	ret

Uitsl_Print_Line:
	push ax
	push cx
	push dx
	push si
	mov ah, 5
	mov dl, al
	int 21h
	mov si, [Decoratie]
	mov dl, [si]
	int 21h
	mov dx, [Naamnaam]
	mov cx, 26
	call Print_print
	mov dl, [si]
	int 21h
	int 21h
	mov cx, 3
	xchg si, bx
	xor bh, bh
	mov bl, '1'
	xchg si, bx
.looploop
	push cx
	mov dl, bl
	int 21h
	mov dx, [Decoratie]
	mov cx, 15
	xchg si, bx
	mov [Poging+3], bl
	inc bl
	xchg si, bx
	call Print_print
	pop cx
	loop .looploop
	mov dl, bh
	int 21h
	call Print_1013
	pop si
	pop dx
	pop cx
	pop ax
	ret

Print_normaal:
	mov byte [Condensed], 15
	jmp Print_start
;	push word [Msg]
;	mov word [Msg], Printen
;	call Statusb
;	push ax
;	push bx
;	push cx
;	push dx
;	push si
;	push bp
;	mov bp, Prestatievelden
;	mov ax, 256
;	int 16h
;	jz .tru2
;	jmp .end
;.tru2
;	;call Print_DS
;	;call Print_condensed
;	mov dx, Sportdag
;	mov cx, 32
;	call Print_print
;	mov dx, Jaar
;	mov cx, 4
;	call Print_print
;	mov dx, Jongens
;	cmp byte [Geslacht], 'M'
;	je .tru100
;	mov dx, Meisjes
;.tru100
;	mov cx, 10
;	call Print_print
;	call Print_1013
;	call Print_1013
;	mov dx, Punten
;	mov cx, 8
;	call Print_print
;	mov dx, Klasse1xmenu+2
;	mov cx, 16
;	call Print_print
;	call Print_1013
;	call Print_1013
;	;call Print_unDS
;	mov dx, Legenda1 + 1
;	mov cx, 4
;	call Print_print
;	mov cx, 67
;	call Print_print
;	call Print_1013
;	mov dx, Legenda2 + 1
;	mov cx, 4
;	call Print_print
;	mov cx, 67
;	call Print_print
;	call Print_1013
;	xor si, si
;	mov cx, [CURRTOTAL]
;	call Print_DS
;.looploop
;	push cx
;	push si
;	call Rechnerp_Calc_Totaal_Punten
;	mov ax, si
;	inc ax
;	call Si_Beg_Record
;	int3
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;	push si
;	mov si, StringBuffer
;	mov cx, 3
;	call Print_String_LField
;	pop si
;	mov ah, 5
;	mov dl, ' '
;	int 21h
;	inc si
;	mov cx, 26
;	mov dx, si
;	call Print_print
;	mov bx, TempPuntenData+10
;	mov cx, 6
;.punten_loop
;	push cx
;	mov cl, 5
;	push si
;	call Textp_Make_String_2Data
;	mov cx, 6
;	call Print_String_LField
;	pop si
;	sub bx, 2
;	pop cx
;	loop .punten_loop
;	mov bx, si
;	add bx, 40
;	mov cl, 5
;	call Textp_Make_String_2Data
;	mov cx, 5
;	call Print_String_LField
;	call Print_1013
;	pop si
;	inc si
;	pop cx
;	cmp cx, [CURRTOTAL]
;	jne .tru40	
;	call Print_unDS
;.tru40
;	loop .looploop
;.end	
;	Toetsm_Clear_Buffer	
;	pop bp
;	pop si
;	pop dx
;	pop cx
;	pop bx
;	pop ax
;	pop word [Msg]
;	call Statusb
;	ret

Print_breed:
	mov byte [Condensed], 18

Print_start:
	push word [Msg]
	mov word [Msg], Printen
	call Statusb
	push ax
	push bx
	push cx
	push dx
	push si
	push bp
	mov bp, Prestatievelden
	mov ax, 256
	int 16h
	jz .tru2
	jmp .end
.tru2
	cmp word [CURRTOTAL], 0
	jne $+5
	jmp .end
	;call Print_DS
	;call Print_condensed
	mov ah, 5
	mov dl, [Condensed]
	int 21h
	mov dx, Sportdag
	mov cx, 32
	call Print_print
	mov dx, Jaar
	mov cx, 4
	call Print_print
	mov dx, Jongens
	cmp byte [Geslacht], 'M'
	je .tru100
	mov dx, Meisjes
.tru100
	mov cx, 10
	call Print_print
	call Print_1013
	call Print_1013
	mov dx, Klasse1xmenu+2
	mov cx, 16
	call Print_print
	call Print_1013
	call Print_1013
	mov dx, BreedPrint
	mov cx, 115
	call Print_print
	call Print_1013
	mov dx, BreedPrint2
	mov cx, 115
	call Print_print
	call Print_1013
	;call Print_unDS
	xor si, si
	mov cx, [CURRTOTAL]
	call Print_DS
.looploop
	push cx
	push si
	call Rechnerp_Calc_Totaal_Punten
	mov ax, si
	inc ax
	call Si_Beg_Record
	cmp cx, [CURRTOTAL]
	je .tru
	mov cx, [si+41]
	cmp [FileHandle], cx
	jne .tru
	;DW2S cx, 0
	jmp .tru20
.tru
	mov cx, [si+41]
	mov word [FileHandle], cx
	mov word [CompareFunction], ax
.tru20
	mov ax, [CompareFunction]
	cmp ax, 1
	je .tru40
	call Print_unDS
.tru40
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	push si
	mov si, StringBuffer
	mov cx, 3
	call Print_String_LField
	pop si
	mov ah, 5
	mov dl, ' '
	int 21h
	inc si
	mov cx, 26
	mov dx, si
	call Print_print
	mov bx, TempPuntenData+10
	mov cx, 6
.punten_loop
	push cx
	mov cl, 5
	push si
	call Textp_Make_String_2Data
	mov cx, 4
	call Print_String_LField
;	push ax
;	mov ax, [bx+12]
;	call Conv_AX2BCD
;	call Conv_BCD2String
;	mov si, StringBuffer
;	pop ax
	add bx, 12
	mov cl, 3
	call Textp_Make_String_2Data
	sub bx, 12
	mov cx, 7
	call Print_String_LField
	mov ah, 5
	mov dl, ' '
	int 21h
	int 21h
	pop si
	sub bx, 2
	pop cx
	loop .punten_loop
	mov bx, si
	add bx, 40
	mov cl, 5
	call Textp_Make_String_2Data
	mov cx, 7
	call Print_String_LField
	call Print_1013
	pop si
	inc si
	pop cx
	dec cx
	jz $+5
;	loop .looploop
	jmp .looploop
	mov ah, 5
	mov dl, 18
	int 21h
.end	
	Toetsm_Clear_Buffer	
	pop bp
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	pop word [Msg]
	call Statusb
	ret

Print_String_LField: ;(string in si, lengte in cx, GEEN CLIPPING)
	push ax
	push bx
	push cx
	push dx
	xor bh, bh
	mov bl, [si]
	cmp bx, cx
	je .tru
	sub cx, bx
	mov dl, ' '
	mov ah, 5
.blankloop:	
	int 21h
	loop .blankloop
.tru
	mov cx, bx
	mov dx, si
	inc dx
	call Print_print
	pop dx
	pop cx
	pop bx
	pop ax
	ret
	
Print1013	db 10, 13
PrintDS		db 27, 71
PrintunDS	db 27, 72
Printcondensed	db 27, 15
Printncondensed	db 18

Print_1013:
	push ax
	push dx
	mov ah, 5
	mov dl, 10
	int 21h
	mov dl, 13
	int 21h
	pop dx
	pop ax
	ret

Print_DS:
	push cx
	push dx
	mov cx, 2
	mov dx, PrintDS
	call Print_print
	pop dx
	pop cx
	ret

Print_unDS:
	push cx
	push dx
	mov cx, 2
	mov dx, PrintunDS
	call Print_print
	pop dx
	pop cx
	ret

Print_condensed:
	push cx
	push dx
	mov cx, 2
	mov dx, Printcondensed
	call Print_print
	pop dx
	pop cx
	ret

Print_ncondensed:
	push cx
	push dx
	mov cx, 1
	mov dx, Printncondensed
	call Print_print
	pop dx
	pop cx
	ret

Print_print: ; callt int21h met ah=40h en bx=4: dx=offset data cx=aantaltekens
	push ax
	push bx
	push cx
	mov ah, 40h
	mov bx, 4
	int 21h
	pop cx
	pop bx
	pop ax
	ret