;    file.inc - file i/o functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

FIp_Close:
	push ax
	push bx
	mov ah, 03Eh
	mov bx, [FileHandle]
	int 21h
	pop bx
	pop ax
	ret

FIp_Open:
	push dx
	mov al, 2
	mov ah, 03Dh
	mov dx, Filename
	int 21h
	pop dx
	ret

FIp_Test:
	push ax
	push bx
	push cx
	push dx
.open 
	call FIp_Open
	jc .nieuw
	mov [FileHandle], ax
	call FIp_Close
.end
	pop dx
	pop cx
	pop bx
	pop ax
	ret
.nieuw
;	push si
;	mov si, BestaatMsg
;	call Bericht
;	pop si
;	jc .end
	mov ah, 03Ch
	mov cx, 0
	mov dx, Filename
	int 21h
	mov word [FileHandle], ax
	call FIp_Close
	mov word [Total], 0
	mov cx, 26
	mov bx, Opgevuld
.fill
	mov byte [bx], 0
	inc bx
	loop .fill
	call FIp_Write_Data
	clc
	jmp .end

FIp_Write_Data:
	push ax
	push bx
	push cx
	push dx
	push bp
	call FIp_Open
	xor bp, bp
	push word [Msg]
	mov word [Msg], WritingMsg
	call Statusb
	pop word [Msg]
	pop bp
	; Seek naar 0
	mov ah, 042h
	mov al, 0
	mov bx, [FileHandle]
	xor cx, cx
	xor dx, dx
	int 21h
	jc .err
	mov ah, 040h
	mov bx, [FileHandle]
	mov cx, 2
	mov dx, Total
	int 21h
	jc .err
	mov ax, [Total]
	mov cx, ax
	shl ax, 1
	add cx, ax
	shl ax, 1
	shl ax, 1
	add cx, ax
	shl ax, 1
	shl ax, 1
	add cx, ax
	mov ah, 040h
	mov bx, [FileHandle]
	mov dx, Leerlingen
	int 21h
	jc .err
	mov cx, 26
	mov ah, 040h
	mov bx, [FileHandle]
	mov dx, Opgevuld
	int 21h
.err
	push bp
	xor bp, bp
	call FIp_Close
	call Statusb
	pop bp
	pop dx
	pop cx
	pop bx
	pop ax
	ret

FIp_Read_Data:   
	push ax
	push bx
	push cx
	push dx
	call FIp_Open
	; Read Header
	mov ah, 03Fh
	mov bx, [FileHandle]
	mov cx, 2
	mov dx, Total
	int 21h
	jc .err
	mov ax, [Total]
	mov cx, ax
	shl ax, 1
	add cx, ax
	shl ax, 1
	shl ax, 1
	add cx, ax
	shl ax, 1
	shl ax, 1
	add cx, ax
	mov ah, 03Fh
	mov bx, [FileHandle]
	mov dx, Leerlingen
	int 21h
	jc .err
	;Opgevuld bytes: MSB 7 6 6 5 4 3 2 1 0 LSB	
	;bit 1 vertelt of de groep bestaat
	;bit 7-2 vertelt of het correspronderende onderdeel is ingevuld
	mov cx, 26
	mov ah, 03Fh
	mov bx, [FileHandle]
	mov dx, Opgevuld
	int 21h
	mov cx, [Total]
	mov si, Leerlingen
	mov bx, Leeftijden
	xor dh, dh
.sanity_loop
	mov dl, [si]
	mov al, [si+28]
	dec dl
	add bx, dx
	cmp byte [bx], 4
	je .change
.tru
	sub bx, dx
	add si, 43
	loop .sanity_loop
	jmp .err
.change
	mov [bx], al
	jmp .tru
.err
;	DW2S ax, 0
;	DW2S dx, 0
	call FIp_Close
	pop dx
	pop cx
	pop bx
	pop ax
	ret	