;    rechner.inc - calculating functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
Rechnerp_Calc_Punten: ;Onderdeel in cx (0 is 1st onderdeel) uitkomst in ax adres persoon in si, mov dx, Factors lea di, [VELDENINFO]
	push bx
	push cx
	push dx
	push di
	push si
	mov al, cl		;cl (num onderdeel bewaren)
	shl cl, 1		
	shl cl, 1
	shl cl, 1
	shl cl, 1		; cl = cl * 16
	add dx, cx
	add dx, cx
	add dx, cx		; dx = dx + 3 * cl
	shr cl, 1		; cl = cl/2
	sub cl, al		; cl = 7 * num onderdeel
	xor bx, bx
	mov bl, 27 ;[di+16]		; bx is offset geslacht in record
	cmp byte [si+bx], 'M'
	je .tru1		; mannelijk?
	add dx, 24		; nee; de helft overslaan
.tru1	
	mov bl, 28 ;[di+23]		; bx is offset leeftijdscat in record
	add di, cx		
	add di, 9		; [di] is offset prestatie in record
	mov cl, [si+bx]		; cl is num leeftijdscat
	mov ch, cl
	shl ch, 1
	add cl, ch
	shl cl, 1		;cl is leeftijdscat*6
	mov ch, bh		;ch = 0
	add dx, cx		;[dx] is eerste factor
	mov bl, [di]
	mov di, dx
	add si, bx
	xor ax, ax
	mov dx, ax
	mov cx, ax
	
	cmp word [si], 10000
	je .end
	mov bx, [di]		;Afsplitsing omdat tijd anders gaat
	cmp bx, [di+2]
	jae .tijd
	mov bx, [si]
	cmp bx, [di]
	jbe .end
	cmp bx, [di+2]
	mov si, ax
	mov ax, 50
	je .end
	jb .formel
	mov si, 50
	add di, 2
.formel		 
	cmp bx, [di+2]
	je .tru
	sub bx, [di]
	call Rechnerp_Mult_50
	mov bx, [di+2]
	sub bx, [di]
.tru3	
	div bx
	shl dx, 1
	cmp bx, dx
	ja .tru
	inc ax
.tru
	add ax, si
.end
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	ret	
.tijd
	mov bx, [si]
	cmp bx, [di]
	jae .end
	mov si, ax
	mov ax, 50
	cmp bx, [di+2]
	je .end
	ja .formel2
	mov si, ax
	add di, 2
.formel2
	neg bx
	add bx, [di]
	call Rechnerp_Mult_50
	mov bx, [di]
	sub bx, [di+2]
	jmp .tru3
	
Rechnerp_Calc_Totaal_Punten: ;(si is numm vd leerling)
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	push bp
	mov cx, 5
	call Si_Beg_Record
	mov dx, Factors
	lea di, [VELDENINFO]
	mov bp, TempPrestData
	mov bx, [si+29]
	mov [bp+10], bx
	mov bx, [si+31]
	mov [bp+8], bx
	mov bx, [si+33]
	mov [bp+6], bx
	mov bx, [si+35]
	mov [bp+4], bx
	mov bx, [si+37]
	mov [bp+2], bx
	mov bx, [si+39]
	mov [bp], bx
	mov bp, TempPuntenData
	xor bx, bx
.optel_loop:
	call Rechnerp_Calc_Punten
	add bx, ax
	mov [bp], ax
	add bp, 2
	loop .optel_loop
	call Rechnerp_Calc_Punten
	mov [bp], ax
	add ax, bx
	mov bx, 41
	mov [si+bx], ax
	pop bp
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret
	
Rechnerp_Update_Totaal_Punten:
	push si
	mov si, [CURRPOS]
	call Rechnerp_Calc_Totaal_Punten
	call [WRITELINE]
	pop si
	ret

Rechnerp_Mult_50:
	shl bx, 1
	rcl cx, 1
	mov ax, bx
	mov dx, cx
	shl bx, 1
	rcl cx, 1
	shl bx, 1
	rcl cx, 1
	shl bx, 1
	rcl cx, 1
	add ax, bx
	adc dx, cx
	shl bx, 1
	rcl cx, 1
	add ax, bx
	adc dx, cx
	ret