;    sportdag.asm - main module of sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
%define even times ($-$$) & 1 db 0
%define CURRTOTAL   bp
%define CURRPOS     bp+2
%define CURRBOVEN   bp+4
%define HORPOS      bp+6
%define HORMAX      bp+7
%define HORMIN      bp+8
%define MINLINE     bp+9
%define MAXLINE     bp+10
%define CURRLINE    bp+11
%define SCROLLBEGIN bp+12
%define SCROLLAANTAL    bp+13
%define WRITELINE   bp+14
%define CLEARLINE   bp+16
%define UPDATEFUNCTION 	bp+18
%define AANTALVELDEN    bp+20
%define VELDENINFO  bp+21
;
	ORG 100h
SECTION .text
	jmp Start
	nop	
Empty_Proc:
	ret
;
%include "CONVERT.INC"    
%include "TEXTCTRL.INC"
;%include "DEBUG.INC"    
%include "RECHNER.INC"
%include "TOETSCTL.INC"
%include "DATABASE.INC"
%include "STATUSB.INC"
%include "FILE.INC"
%include "PRINTER.INC"
;
Start:    
;	mov byte [DOSString], 12
	mov byte [DOSString+1], 12
;	mov dx, DOSString
;	mov ah, 0ah
;	int 21h
;	Toetsm_Wacht

	mov cx, 13
	mov si, 129
;	mov di, 0
	mov bx, DOSString+1
.copy_loop
	mov al, [si]
	mov [bx], al
;	mov [es:di], al
	add di, 2
	inc si
	inc bx
	loop .copy_loop
;	Toetsm_Wacht
;	call Textp_Init
	cmp byte [DOSString+1], 32
	je $+5
	jmp err	
	
	cmp byte [DOSString+2], 'j'
	jne .tru
	mov byte [Geslacht], 'M'
	jmp .tru3
.tru	
	cmp byte [DOSString+2], 'm'
	je $+5
	jmp err
	mov byte [Geslacht], 'V'
.tru3
	mov al, [DOSString+2]
	mov [Filename], al
	mov al, [DOSString+3]
	mov [Filename+1], al
	mov al, [DOSString+4]
	mov [Filename+2], al
	mov al, [DOSString+5]

	mov [Filename+3], al
	mov al, [DOSString+6]
	mov [Filename+4], al
	mov al, [DOSString+7]
	mov [Filename+5], al
	mov al, [DOSString+8]
	mov [Filename+6], al
	mov al, [DOSString+9]
	mov [Filename+7], al
	cmp byte [DOSString+10], '.'
	je $+5
	jmp err
	cmp byte [DOSString+11], 'b'
	je $+5
	jmp err
	cmp byte [DOSString+12], 's'
	je $+5
	jmp err
	cmp byte [DOSString+13], 'd'
	je $+5
	jmp err
;	cmp byte [DOSString+14], 13
;	je $+5
;	jmp err

;	mov ah, 9
;	mov dx, DrukToets
;	int 21h
;;	Toetsm_Wacht

	call Textp_Init

	mov bx, Somedata
	mov cx, 9
.looploop2
	push cx
	mov di, [bx]
	mov si, [bx+2]
	mov cx, [bx+4]
	add bx, 6
	Textm_CXS_DI
	pop cx
	loop .looploop2
;	mov di, (80*11+4)*2
;	mov si, StartupMsg
;	mov cx, 18	
;	Textm_CXS_DI
;	mov di, (80*12+4)*2
;	mov si, StartupMsg+19
;	mov cx, 18
;	Textm_CXS_DI
;	mov di, (80*14+2)*2
;	mov si, StartupMsg+38
;	mov cx, 16
;	Textm_CXS_DI
;	mov di, (80*15+2)*2
;	mov si, StartupMsg+55
;	mov cx, 24
;	Textm_CXS_DI
;	mov di, (80*17+2)*2
;	mov si, StartupMsg+82
;	mov cx, 24
;	Textm_CXS_DI
;	mov di, (80*18+2)*2
;	mov si, StartupMsg+107
;	mov cx, 21
;	Textm_CXS_DI
;	mov di, (80*19+2)*2
;	mov si, StartupMsg+129
;	mov cx, 23
;	Textm_CXS_DI
;	mov di, (80*20+2)*2
;	mov si, StartupMsg+154
;	mov cx, 23
;	Textm_CXS_DI
;	mov di, (80*21+2)*2
;	mov si, StartupMsg+177
;	mov cx, 13
;	Textm_CXS_DI


;	DB2S [DOSString+1], 0
	mov ax, LoadingMsg   
	mov [Msg], ax
	xor bp, bp
	call Statusb
;	DB2S [DOSString+1], 6
	
	;Toetsm_Wacht
	; db init
	mov cx, 1024
	mov si, Reference
	mov di, Leerlingen
ref_fill_loop:
	mov [si], di
	add si, 2
	add di, 43
	loop ref_fill_loop
;		DB2S [DOSString+1], 12

	mov byte [GTotal], 26
	; Init groepen
	mov bx, Leeftijden
	mov si, GroepRef
	mov cx, 26
	mov al, 1
	mov ah, 4
fill2_loop:
	mov [si], al
	mov [bx], ah
	inc si
	inc bx
	inc al
	loop fill2_loop
;	DB2S [DOSString+1], 18

	; Load File
	; Open
	Toetsm_Clear_Buffer
	mov word [Total], 1024
	call FIp_Test
	jnc $+5	
	jmp err
	cmp word [Total], 1024
	jne .tru12
	call FIp_Read_Data
.tru12	
;	mov di, (80*14+4)*2
;	mov si, LLN
;	mov cx, 12
;	Textm_CXS_DI
;	mov ax, [Total]
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;	mov si, StringBuffer
;	xor ch, ch
;	mov cl, [si]
;	inc si
;	Textm_CXS_DI
;	mov di, (80*15+4)*2
;	mov si, GRPN
;	mov cx, 9
;	Textm_CXS_DI
;	mov ax, [GTotal]
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;	mov si, StringBuffer
;	xor ch, ch
;	mov cl, [si]
;	inc si
;	Textm_CXS_DI
	mov ax, [Total]
	mov bp, Prestatievelden
	mov word [CURRTOTAL], ax
	mov word [CURRPOS], 0
	mov word [CURRBOVEN], 0
	mov ax, EmptyMsg
	mov [Msg], ax
	call Statusb
	
	Toetsm_Clear_Buffer
	
	mov word [Menu], Hoofdmenu
	mov word [Menu+2], Hoofdmenuinfo
	push bp
	mov bp, Menuvelden
	call DBp_Load_Menuvelden
	push word [Msg]
	mov word [Msg], HoofdmenuMsg
	call DBp_Edit_Velden
	pop word [Msg]
	call DBp_Save_Menuvelden
	pop bp
;	call FIp_Write_Data

	Toetsm_Clear_Buffer
	jmp goforth
err:
	mov ah, 9
	mov dx, StartupMsg
	int 21h
	
;	mov ah, 9
;	mov dx, Terechtwijzing
;	int 21h
;	mov di, 0
;	mov cx, 12
;	mov si, 129
;.looplooploop
;	mov al, [si]
;	inc si
;	Textm_Output_AL_DI
;	loop .looplooploop

;	Toetsm_Wacht
	jmp docontinue
goforth:	
	mov ax, 3
	int 10h
docontinue:
	mov ax, 04C00h
	int 21h
;
SECTION .data
Msg         dw 0
TextSeg     dw 0B800h
CRTAddr     dw 03D4h
;StartupMsg  db 'Sportdag.com (C) 2002 Rik Snel v1.0 Voor Rsg. Broklede te Breukelen.', 10, 13
StartupMsg  db 'Sportdag.com v1.01 (C) 2002 Rik Snel. Geschreven voor: Rsg. Broklede, Breukelen.', 10, 13
;		db 'Geschreven in 100% assembler. Geassembleerd door The Netwide Assembler.',10,13,10,13
;		db 'Deze executable en de sourcecode vallen onder de GNU General Public License.', 10, 13
		db 'Dit programma valt onder de GNU General Public License v2. Zie de file', 10, 13
		db 'COPYING of www.gnu.org voor details.', 10, 13, 10, 13
;DrukToets	db 'Druk op een toets om verder te gaan.', 10, 13, '$'
;		db 'Voer de filename met de database (of waar de database in moet komen), in', 10,13
;		db 'De eerste vier letters in de filename zijn "jong" of "meis", de volgende vier',10,13
;		db 'zijn het jaartal (bijvoorbeeld 2002), de extensie is .bsd"', 10,13
;		db 'Voorbeelden: jong2001.bsd, meis2121.bsd, jong1995.bsd, meis1995.bsd',10,13,10,13
;		db 'Filename: $'
Terechtwijzing  db 'Dit programma moet worden opgestart door menu.bat tenzij je weet wat je doet.',10,13,'$'
Somedata dw (80*11+4)*2, StartupMsg, 18, (80*12+4)*2, StartupMsg+19, 18
	 dw (80*14+2)*2, StartupMsg+38, 16, (80*15+2)*2, StartupMsg+55, 24
	 dw (80*17+2)*2, StartupMsg+82, 24, (80*18+2)*2, StartupMsg+107, 21
         dw (80*19+2)*2, StartupMsg+129, 23, (80*20+2)*2, StartupMsg+154, 23
	 dw (80*21+2)*2, StartupMsg+177, 13
LoadingMsg  db 15, 'Bezig met laden'
WritingMsg  db 17, 'Bezig met opslaan'
EmptyMsg    db 0
Wit         db 07h
Bright      db 0Fh
Inv         db 070h
;Wit	    db 2
;Bright	    db 10
;Inv	    db 2*16
Comma       db 0h   
Deelinvoer  db 0h
LLN         db ' leerlingen'
;GRPN        db 'Groepen: '
Poging	    db '    e poging   '
Paraaf      db 'Paraaf:'
Onderdeel   db 'Onderdeel:'
Groep	    db 'Groep:'
GroepArray  db '12-13', '14-15', '16-17', '18-19'
OnderArray  db 'Hardlopen   ', 'Hoogspringen', 'Verspringen ', 'Kogelstoten ', 'Speerwerpen ', 'Discuswerpen'
BreedPrint  db '                               Hardlopen    Hoogspringen Verspringen  Kogelstoten  Speerwerpen  Discuswerpen Totaal'
BreedPrint2 db '           Naam                pt   tijd(s) pt hoogte(m) pt  afst.(m) pt  afst.(m) pt  afst.(m) pt  afst.(m) PUNTEN'
Legenda3    db '                            Onderdeel    Leeftijd   --Oordeel--   Grp HHVKSD'
;Legenda3    db  '', 29, 'Onderdeel', 4, 'Leeftijd', 3, '--Oordeel--', 3, 'G. HHVKSD'
Legenda4    db '                                     Geslacht     0pt   50pt 100pt         '
Select      db '                                                                      '
Legenda5    db 'ĳ         '
Legenda1    db '            Naam              Hoogspringen Kogelstoten Discuswerpen         '
Legenda2    db '                          Hardlopen Verspringen  Speerwerpen Totaal         '
Lijst       db '                                                                     '
InvoerErrorMsg  db 46, 'Invoerfout: Esc = Afbreken, Enter = Herstellen'
AfstandTip  db 35, 'Typ de afstand (m) in. (0,00-99,99)' 
HoogteTip   db 34, 'Typ de hoogte (m) in. (0,00-99,99)' 
TijdTip     db 32, 'Typ de tijd (s) in. (0,00-99,99)' 
;Punten	    db 'PUNTEN '
NaamTip     db 15, 'Typ de naam in.'
;LeeftijdTip db 59, 'Toggle leeftijd met de spatiebalk of typ 2,3,4,5,6,7,8 of 9'
;GeslachtTip db 47, 'Toggle geslacht met de spatiebalk of typ m of v'
KiesGroep   db 59, 'Selecteer groep en onderdeel om in te vullen of te wijzigen'
EditGroep   db 47, 'Selecteer groep om aan te maken en/of te editen'
LLInv       db 59, 'Deelnemers invoeren (ins=invoegen, del=wissen, esc=stoppen)'
;GroepTip    db 30, 'Typ het groepnummer in. (1-99)'
VeldTip     db 29, 'Kies veld met pijltjestoetsen'
Selecteren  db 21, 'Bezig met selecteren.'
SorteerMsg  db 19, 'Bezig met sorteren.'
;BestaatMsg  db 61, 'File bestaat niet, nieuwe file maken? (Enter = Ja, Esc = Nee)'
InvWijzHlp  db 50, 'Voer de resultaten van de groep in (Esc = Stoppen)'
UitslWijz   db 56, 'Uitslagen van leerling wijzigen? (Enter = Ja, Esc = Nee)'
WissenMsg   db 40, 'Leerling wissen? (Enter = Ja, Esc = Nee)'
MarkerenMsg db 58, 'Onderdeel als "Ingevuld" markeren? (Enter = Ja, Esc = Nee)'
WijzigenMsg db 56, 'Onderdeel al ingevuld; wijzigen? (Enter = Ja, Esc = Nee)'
Selecteer   db 61, 'Selecteer een groep om een uitslagenformulier van te printen.'
Printen	    db 21, 'Bezig met printen....'
Wijzig      db 35, 'Wijzig de uitslagen van de leerling'
KiesLT      db 63, 'Nieuwe groep maken; kies leeftijdscategorie 2,4,6,8 of Esc=Stop'
GeenLLN	    db 60, 'Geen leerling gevonden met de gevraagde naam (druk op Enter)'
Full	    db 64, 'Er kunnen geen leerlingen bij, zijn jullie gefuseerd? (max 1024)'
HoofdmenuMsg db 63,'Kies een menu-item met de pijltjestoetsen (Esc = menu verlaten)'
NietUniek   db  64,'Naam bestaat al (druk op Enter en voeg bijvoorbeeld de klas toe)'
VraagNaam db    62,'Typ een deel van de naam van de gezochte leerling (Esc = stop)'
MeerNaam  db    63,'Vul de naam aan tot er maar 1 leerling over blijft (Esc = stop)'
Jongens	db ' - Jongens'
Meisjes db ' - Meisjes'
Sportdag	db 'Rsg. Broklede Atletiek Sportdag '
Leeg        db 5, '_____'
Ingevuld    db 254
ToetsVoorEdit dw 0
Condensed	db 15
MovesDown	dw 0
NietIngevuld    db ''
Bestaand	db '>'
NietBestaand	db '-'
Filename db 'jong'
Jaar 	db '1997'
	db '.bsd', 0
;
Hoofdmenu  	db '     HOOFDMENU      '
		dw DBp_Setup_Groepen_Edit
		db 'Deelnemers inv/wijz '
		dw DBp_Setup_Uitsl_Edit
		db 'Uitslagen inv/wijz  '
		dw DBp_Setup_Factoren_Menu
		db 'Factoren menu       '
		dw DBp_Setup_Klassement_Menu
		db 'Klassement opmaken  '
		dw DBp_Setup_Extra_Menu
		db 'Extra               '
;
Extramenu  	db '       EXTRA        '
		dw DBp_Setup_Uitslagen_Lijst_Printen
		db 'Print uitsl. bladen '
		dw DBp_Zoek_Leerling
		db 'Zoek ll/Wijz. Uitsl.'
;
Factorenmenu 	db '    FACTORENMENU    '
		dw DBp_Setup_Factor_Edit
		db 'Factoren zien       '
		dw Print_Factoren
		db 'Print Factoren      '
;
Klassementmenu	db ' KLASSEMENT OPMAKEN '
		dw DBp_Setup_Klasse12_Menu
		db '12-13 jaar          '
		dw DBp_Setup_Klasse14_Menu
		db '14-15 jaar          '
		dw DBp_Setup_Klasse16_Menu
		db '16-17 jaar          '
		dw DBp_Setup_Klasse18_Menu
		db '18-19 jaar          '
		dw DBp_Setup_Klasse29_Menu
		db 'Algemeen klassement '
;
Klasse1xmenu	db '  KLASSEMENT 1x-1y  '
		dw DBp_Setup_Preview
		db 'Bekijken            '
		dw Print_breed
		db 'Breed printen       '
		dw Print_normaal
		db 'Condensed printen   '
;
Prestatievelden:
		dw 0, 1, 0
		db 0, 0, 0, 10, 23, 10, 1, 68
		dw Textp_Write_Line, Textp_Clear_Text_Line, Rechnerp_Update_Totaal_Punten
;		db 10
		db 8
;		db 1, 2, 0
;		dw GroepTip, Empty_Proc; DBp_Input_Groep
		db 1, 26, 1
		dw NaamTip, DBp_Input_Naam
;		db 31, 1, 27
;		dw GeslachtTip, Empty_Proc ; DBp_Input_Geslacht
;		db 33, 5, 28
;		dw LeeftijdTip, Empty_Proc ; DBp_Input_Leeftijd
		db 28, 5, 29
		dw TijdTip, DBp_Input_Prestatie
		db 34, 5, 31
		dw HoogteTip, DBp_Input_Prestatie
		db 40, 5, 33
		dw AfstandTip, DBp_Input_Prestatie
		db 46, 5, 35
		dw AfstandTip, DBp_Input_Prestatie
		db 52, 5, 37
		dw AfstandTip, DBp_Input_Prestatie
		db 58, 5, 39
		dw AfstandTip, DBp_Input_Prestatie
		db 64, 4, 41
		dw EmptyMsg, Toetsp_Clear_Buffer
;
Groepinvoer:
		dw 26, 0, 0 ;26 omdat we alle groepen willen zien
		db 0, 0, 0, 2, 23, 2, 70, 9
		dw Textp_IWrite_Line
		dw Textp_SClear_Line, FIp_Write_Data
		db 1
		db 73, 6, 0
		dw LLInv, DBp_Setup_Groep_Inv
;
Selecteervelden:
		dw 26, 0, 0 
		db 0, 5, 0, 2, 23, 2, 70, 9
		dw Textp_SWrite_Line
		dw Textp_SClear_Line, FIp_Write_Data
		db 6
		db 73, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
		db 74, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
		db 75, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
		db 76, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
		db 77, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
		db 78, 1, 0
		dw InvWijzHlp, DBp_Setup_Inv
;
Factorvelden:
		dw 48, 0, 0
		db 0, 2, 0, 3, 6, 3, 30, 37
		dw Textp_FacWrite_Line, Textp_FacClear_Line, Empty_Proc
		db 3
		db 51, 5, 0
;		dw EmptyMsg, DBp_Input_Factor
		dw EmptyMsg, Toetsp_Clear_Buffer
		db 57, 5, 2
		dw EmptyMsg, Toetsp_Clear_Buffer
		db 63, 5, 4
		dw EmptyMsg, Toetsp_Clear_Buffer
;
Menuvelden:
		dw 4, 0, 0
		db 0, 0, 0, 2, 6, 2, 0, 30
		dw Textp_MenuWrite_Line, Textp_MenuClear_Line, Empty_Proc
		db 1
		db 5, 20, 0
		dw HoofdmenuMsg, DBp_MenuDispatcher
;
Hoofdmenuinfo	dw 5, 0
		db 2
;
Extramenuinfo	dw 2, 0
		db 2
;
Factorenmenuinfo	dw 2, 0
		db 2
;
Klassemenuinfo	dw 5, 0
		db 2
;
Klas1xmenuinfo	dw 3, 0
		db 2
;
Facts		db 8, 'DEFAULT0'
Factors:
INCBIN"FACTORS.DAT"
;
SECTION .bss
FileHandle  	resw 1
Reference   	resw 1024
Total       	resw 1
Menu	    	resw 2
WMenu	    	resw 2
Naamnaam	resw 1
CompareFunction resw 1
Decoratie	resw 1
Geslacht	resb 1
GTotal		resb 1
BCDAccum    	resb 5
DOSString	resb 1
StringBuffer    resb 81
StringStack 	resb 81
FTPBuffer   	resb 10
TempPuntenData	resw 6
TempPrestData   resw 6
CursorStart	resb 1
CursorEnd   	resb 1
GroepRef	resb 26
Opgevuld    	resb 26
Leeftijden	resb 26
Leerlingen  	resb 44032
;