;    statusb.inc - this file implements the statusbar in sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
Statusb: 
	push ax
	push bx
	push cx
	push dx
	push di
	push si
;   	DW2S bp, 0
	xor dx, dx
	call PushString 
	mov di, 59*2
	mov ax, [Total]
	mov byte [LLN+9], 'e'
	mov byte [LLN+10], 'n'
	cmp ax, 1
	jne .tru56
	mov byte [LLN+9], 196
	mov byte [LLN+10], 196
.tru56
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	mov si, StringBuffer
	mov al, 196
	mov cx, 4
	call Textp_Fill_RField_DI
;	Textm_CXS_DI
	mov cx, 11	
	mov si, LLN
	Textm_CXS_DI
;	mov ax, [GTotal]
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;	mov si, StringBuffer
;	xor ch, ch
;	mov cl, [si]
;	inc si
;	Textm_CXS_DI
;	mov si, GRPN
;	mov cx, 8
;	Textm_CXS_DI
;	
	mov di, 80 * 24 * 2
	mov al, ''
	Textm_Output_AL_DI
	mov cx, 64
	mov si, [Msg]
	Textm_Fill_LField_DI
	cmp bp, 0
	jne .tru
	mov al, 196
	mov cx, 15
	Textm_Fill_DI_AL
	jmp .end
.tru	
	mov bx, [CURRPOS]
	mov al, 25
	inc bx
	cmp bx, [CURRTOTAL]
	jl .pijltje_neer
	mov al, 196
.pijltje_neer:
	Textm_Output_AL_DI
	mov al, 24
	cmp bx, 1
	ja .pijltje_op
	mov al, 196
.pijltje_op:
	Textm_Output_AL_DI
	mov ax, [CURRPOS]
	inc ax
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	mov si, StringBuffer
	mov al, 196
	mov cx, 6
	call Textp_Fill_RField_DI
	mov al, '/'
	Textm_Output_AL_DI
	mov ax, [CURRTOTAL]
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	mov al, 196
	mov cx, 6
	call Textp_Fill_LField_DI
.end
    	call PopString
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret

PushString:
	push ax
	push cx
	push di
	push si
	xor cx, cx
	mov di, StringStack
	mov si, StringBuffer
	mov cl, [si]
	mov [di], cl
	cmp cx, 80
	ja .snel_klaar
	jcxz .snel_klaar
.mov_loop:
	inc si
	inc di
	mov al, [si]
	mov [di], al
	loop .mov_loop
.snel_klaar:
	pop si
	pop di
	pop cx
	pop ax
	ret
	
PopString:
	push ax
	push cx
	push di
	push si
	xor cx, cx
	mov si, StringStack
	mov di, StringBuffer
	mov cl, [si]
	mov [di], cl
	cmp cx, 80
	ja .snel_klaar
	jcxz .snel_klaar
.mov_loop:
	inc si
	inc di
	mov al, [si]
	mov [di], al
	loop .mov_loop
.snel_klaar:
	pop si
	pop di
	pop cx
	pop ax
	ret
	